package me.Demon.DemonShiTu.guimanager;

import me.Demon.Compat.VexCompatGui;
import me.Demon.DemonLevels.api.DLevelAPI;
import me.Demon.DemonOnlineTime.DtimeAPI;
import me.Demon.DemonPlugin.DemonAPI;
import me.Demon.DemonShiTu.Event.DshituEvent;
import me.Demon.DemonShiTu.Main;
import me.Demon.DemonShiTu.ShiTuAPI;
import me.Demon.DemonShiTu.data.ShiFuData;
import me.Demon.DemonShiTu.manager.DataManager;
import me.Demon.DemonShiTu.util.StackLibrary;
import net.minecraft.server.v1_12_R1.NBTTagCompound;
import org.bukkit.Bukkit;
import org.bukkit.Material;
import org.bukkit.Sound;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.inventory.ClickType;
import org.bukkit.event.inventory.InventoryClickEvent;
import org.bukkit.inventory.Inventory;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.meta.ItemMeta;

import java.util.ArrayList;
import java.util.List;

public class OnlineTeacherGui implements Listener {

    public static String invTitle = "师徒系统 - 活跃的大师(在线的则会显示)";

    @EventHandler
    public void onClick(InventoryClickEvent e){
        Player p = (Player) e.getWhoClicked();
        String name = p.getName();
        Inventory inv = e.getInventory();
        int rawSlot = e.getRawSlot();
        ItemStack item = e.getCurrentItem();
        if(inv != null && inv.getTitle().equalsIgnoreCase(invTitle)){
            e.setCancelled(true);
            if(!DemonAPI.itemIsNull(item) && !DemonAPI.itemIsLore(item)) {
                if (rawSlot >= 9 && rawSlot < inv.getSize() - 9) {
                    if (e.getClick() != ClickType.SHIFT_LEFT) {
                        DemonAPI.sendMessage(p, "请按下 §eSHIFT+左键 §a进行拜师.", Sound.ENTITY_VILLAGER_NO);
                        return;
                    }
                    p.closeInventory();
                    long joinTime = p.getFirstPlayed();// 获取玩家加入服务器的时间
                    // 计算玩家已加入服务器超过多少天 (当前时间 - 加入时间)
                    int joinDay = (int) ((System.currentTimeMillis() - joinTime) / 1000 / (24 * 60 * 60));
                    // 超过天数的阈值
                    int maxJoinDays = 15;
                    if (joinDay >= maxJoinDays) {
                        DemonAPI.sendMessage(p, "非常抱歉,你已经加入服务器§e<" + maxJoinDays + "天>§a已经不能拜师了.", Sound.ENTITY_VILLAGER_NO);
                        return;
                    }
                    // 判断玩家是否已经出师
                    if (ShiTuAPI.isTeacherExit(name)) {
                        DemonAPI.sendMessage(p, "非常抱歉,你已 §e出师 §a无法成为其他人的徒弟.", Sound.ENTITY_VILLAGER_NO);
                        return;
                    }
                    DataManager dataManager = Main.dataManager;
                    // 判断玩家是否已经拜师
                    if (dataManager.isPlayerExitTeacher(name)) {
                        DemonAPI.sendMessage(p, "非常抱歉,每名玩家只能拜一位师傅.", Sound.ENTITY_VILLAGER_NO);
                        return;
                    }
                    NBTTagCompound nbt = StackLibrary.getNBT(item);
                    if (nbt.hasKey("sfName")) {
                        String sfName = nbt.getString("sfName");
                        List<String> applicationList = dataManager.getApplyForList(sfName);// 获取申请列表
                        if (applicationList.contains(name)) {
                            DemonAPI.sendMessage(p, "你已经发送过拜师请求，请耐心等待对方同意。", Sound.ENTITY_VILLAGER_NO);
                            return;
                        }
                        applicationList.add(name);// 将玩家加入申请列表
                        dataManager.setApplyForList(sfName, applicationList); // 刷新申请列表
                        DemonAPI.sendMessage(p, "成功发送拜师请求，请耐心等待对方同意。", Sound.ENTITY_EXPERIENCE_ORB_PICKUP);
                        Player sfPlayer = Bukkit.getPlayer(sfName);
                        if (sfPlayer != null) {
                            DemonAPI.sendMessage(sfPlayer, "您新收到有一条拜师请求等待处理.", Sound.ENTITY_VILLAGER_YES);
                        }
                        DshituEvent event = new DshituEvent(p, sfName);
                        Bukkit.getPluginManager().callEvent(event);
                    }
                }
            }
        }
    }

    public static void OpenGui(Player player){
        Inventory inv = Bukkit.createInventory(null,54,invTitle);
        DataManager dataManager = Main.dataManager;
        for (String sfName : dataManager.getShiFuDataMap().keySet()){
            Player sfPlayer = Bukkit.getPlayer(sfName);
            if(sfPlayer != null) {
                ShiFuData shiFuData = dataManager.getTeacherData(sfName);
                inv.addItem(ShiFuSkull(shiFuData));
            }
        }
        for (int i = 0; i < 9; i++) {inv.setItem(i, DemonAPI.glass(15,"§a§l↓↓§6已出师的玩家列表§a§l↓↓"));}
        for (int i = 45; i < 54; i++) {inv.setItem(i, DemonAPI.glass(15,"§a§l↑↑§c当日在线60分钟才会显示§a§l↑↑"));}
        inv.setItem(4,StackLibrary.tudiInfoShow());
        player.openInventory(inv);
    }

    public static ItemStack ShiFuSkull(ShiFuData fuData){
        String sfName = fuData.getName();
        ItemStack item = new ItemStack(Material.BOOK);
        ItemMeta meta = item.getItemMeta();
        meta.setDisplayName("§b§l★§7名称: §6§l"+sfName);
        List<String> lore = new ArrayList<>();
        int levels = (int) DLevelAPI.getOffPlayer_Level(sfName);
        lore.add("§a§l★§7级别: §dLv."+ levels);
        int time = DtimeAPI.getTime(sfName);
        lore.add("§a§l★§7今日活跃: §a"+ time+"分钟");
        lore.add("§a§l★§7收徒数量: §e" + fuData.getTudiList().size() + "名");
        int top = VexCompatGui.getTop_self(sfName);
        lore.add("§a§l★§7战力排行: §b" + top + "名");
        lore.add("§a§l★§7经验加成: §d"+ShiTuAPI.getExpDouble(sfName)+"%");
        lore.add("§a§l★§7最后一次上线: §c"+DemonAPI.LongToStringData(fuData.getLoginTime(),"yyyy年MM月dd日 HH:mm"));
        lore.add(" ");
        lore.add("§9§l★ §6SHIFT+左键 §7点击拜他为师");
        meta.setLore(lore);
        item.setItemMeta(meta);
        NBTTagCompound nbt = StackLibrary.getNBT(item);
        nbt.setString("sfName",sfName);
        return StackLibrary.setNBT(item,nbt);
    }
}
