package me.Demon.DemonShiTu.guimanager;

import me.Demon.Compat.VexCompatGui;
import me.Demon.DemonPlugin.DemonAPI;
import me.Demon.DemonShiTu.Main;
import me.Demon.DemonShiTu.ShiTuAPI;
import me.Demon.DemonShiTu.data.ShiFuData;
import me.Demon.DemonShiTu.manager.DataManager;
import me.Demon.DemonShiTu.util.StackLibrary;
import org.bukkit.Bukkit;
import org.bukkit.Sound;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.inventory.InventoryClickEvent;
import org.bukkit.inventory.Inventory;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.meta.ItemMeta;

import java.text.DecimalFormat;
import java.util.ArrayList;
import java.util.List;

public class TudiGui implements Listener {

    public static String invTitle = "师徒系统 - 我的师傅";

    @EventHandler
    public void onClick(InventoryClickEvent e){
        Player p = (Player) e.getWhoClicked();
        Inventory inv = e.getInventory();
        int rawSlot = e.getRawSlot();
        ItemStack item = e.getCurrentItem();
        if(inv != null && inv.getTitle().equalsIgnoreCase(invTitle)){
            e.setCancelled(true);
            if(rawSlot == 6){
                p.closeInventory();
                p.playSound(p.getLocation(), Sound.BLOCK_COMPARATOR_CLICK,1.6F,1.8F);
                DataManager dataManager = Main.dataManager;
                if(!dataManager.isPlayerExitTeacher(p.getName())){
                    DemonAPI.sendMessage(p,"你需要拜师后才能解除师徒关系.",Sound.ENTITY_VILLAGER_NO);
                    return;
                }
                int level = p.getLevel();
                int price = 50000;
                if(level >= 90){
                    price = 1000000;
                }else if(level >= 80){
                    price = 500000;
                }else if(level >= 60){
                    price = 200000;
                }else if(level >= 40){
                    price = 100000;
                }
                String money_format = new DecimalFormat(",###").format(price);
                if(!DemonAPI.hasMoney(p,price)){
                    DemonAPI.sendMessage(p,"你需要支付§6"+money_format+"金币§a才能解除师徒关系.",Sound.ENTITY_VILLAGER_NO);
                    return;
                }
                // 从玩家 p 的账户中扣除金额 price
                DemonAPI.takeMoney(p, price);
                // 获取玩家 p 的名字
                String name = p.getName();
                // 根据玩家的名字从数据管理器中获取其师傅的名字
                String sfName = dataManager.getTeacherName(name);
                // 根据师傅的名字从数据管理器中获取师傅的数据
                ShiFuData fuData = dataManager.getTeacherData(sfName);
                // 从师傅的数据中移除该玩家（徒弟）的名字
                fuData.removeTudiList(name);
                // 保存师傅的数据以反映更改
                fuData.SaveData();
                Player sfPlayer = Bukkit.getPlayer(sfName);
                if(sfPlayer != null){
                    DemonAPI.sendMessage(sfPlayer,"您的徒弟 §e"+name+" §a已与你解除师徒关系.",Sound.ENTITY_EXPERIENCE_ORB_PICKUP);
                }
                DemonAPI.sendMessage(p,"成功与 §e"+sfName+" §a解除师徒关系.",Sound.ENTITY_EXPERIENCE_ORB_PICKUP);
            }
        }
    }

    public static void OpenGui(Player player){
        Inventory inv = Bukkit.createInventory(null,54,invTitle);
        inv.setItem(2, StackLibrary.tudiInfoShow());
        DataManager dataManager = Main.dataManager;
        if(!dataManager.isPlayerExitTeacher(player.getName())){
            DemonAPI.sendMessage(player,"你需要拜师后才能查看.",Sound.ENTITY_VILLAGER_NO);
            player.closeInventory();
            return;
        }
        String sfName = dataManager.getTeacherName(player.getName());
        ShiFuData fuData = dataManager.getTeacherData(sfName);
        inv.setItem(6, HeadlSkull(player.getName(),fuData));
        player.openInventory(inv);
    }

    public static ItemStack HeadlSkull(String playName,ShiFuData fuData){
        String sfName = fuData.getName();
        ItemStack item = new ItemStack(449, 1);
        ItemMeta meta = item.getItemMeta();
        meta.setDisplayName("§e§l拜师详情查看");
        List<String> lore = new ArrayList<>();
        lore.add("§a§l★§7我的名称: §6"+ playName);
        lore.add("§a§l★§7师傅名称: §6"+ sfName);
        lore.add("§a§l★§7师门成员: §e"+ fuData.getTudiList().size()+"名");
        int top = VexCompatGui.getTop_self(sfName);
        lore.add("§a§l★§7战力排行: §b" + top + "名");
        lore.add("§a§l★§7经验加成: §d"+ShiTuAPI.getExpDouble(sfName)+"%");
        lore.add("§a§l★§7最后一次上线: §c"+DemonAPI.LongToStringData(fuData.getLoginTime(),"yyyy年MM月dd日 HH:mm"));
        lore.add("§7#等级大于85级后无法获得经验加成Buff");
        lore.add(" ");
        lore.add("§c§l★§7点击与师傅解除关系");
        meta.setLore(lore);
        item.setItemMeta(meta);
        return item;
    }
}
